part of xwidgetbase;

class XfxUpdater extends StatefulWidget {
  XfxUpdater({
    Key? key,
    this.title_Text = "",
    this.title_Color,
    this.title_Style,
    required this.version_APP,
    this.onCancel,
    this.onUpdate,
    required this.nextPage_WithOutUpdate,
    required this.name_APP,
  }) : super(key: key);
  final String? title_Text;
  final Color? title_Color;
  final TextStyle? title_Style;
  final String? version_APP;
  final String name_APP;
  final String? nextPage_WithOutUpdate;
  final Function()? onUpdate;
  final Function()? onCancel;

  @override
  _XfxUpdaterState createState() => _XfxUpdaterState();
}

class _XfxUpdaterState extends State<XfxUpdater> {
  bool isBusy = false;
  bool XUpdateEnabled = true;
  String latestVers = "";
  late XAzureStorage xb;
  String xbConnString = XMainApp.blob_ConnString ?? "";
  Widget? page;
  @override
  void initState() {
    super.initState();
    xb = XAzureStorage.parse(xbConnString);
    XCheckForUpdates();
  }

  Future<Widget?> XCheckForUpdates() async {
    if (XUpdateEnabled.not()) return null; //david 05/10/2022 09:58:53

    if (xbConnString != null || xbConnString != "") {
      var appUpdatesHistoryFile = await xb.getBlob("xupdater/${XMainApp.blob_nameAPP}.txt");
      if (appUpdatesHistoryFile.statusCode == 200) {
        var x = await appUpdatesHistoryFile.stream.bytesToString();
        if (x != "") {
          latestVers = x.GetLine(x, 0).split('\t')[0];
        }
        //se l'ultima versione è diversa da quella dell'app allora scarico l'apk dal blob
        if (latestVers != widget.version_APP) {
          setState(() {
            page = _buildUI();
          });
          // update_APP();
        }
        return page;
      }
    } else {
      Navigator.pushNamed(context, widget.nextPage_WithOutUpdate!);
      return null;
    }
  }

  update_APP() async {
    setState(() {
      isBusy = true;
    });
    var downDirs = await getExternalStorageDirectories(); //appDocumentFolder;
    var baseAppDir = downDirs!.first;
    var outPath = baseAppDir.path; // "";
    var msg = "Ho trovato una nuova versione: ${latestVers}, la sto scaricando ... attendi prego.";
    print("${XMainApp.blob_nameAPP} ${latestVers} DownloadToFile ... in ${outPath}");

    //Scarico l'apk da blob
    var x = await xb.getBlob("${XMainApp.blob_nameAPP}/${XMainApp.blob_nameAPP}-${latestVers}.apk");
    print(x.statusCode);

    var d = DateTime.now();
    var UIfile = await XLibStorage.CreateFile(XMainApp.blob_nameAPP ?? "", extensionFile: "apk", path: outPath);

    print(UIfile!.path); //baseDir.path + "/" + "MELapp.apk"); //${sex.app_Version}
    var buffer = await x.stream.toBytes();
    await UIfile.writeAsBytes(buffer);
    var e = DateTime.now();
    print(e.difference(d).inSeconds.toString());
    // var file = await File(outPath + "/MELapp.apk");
    var u = Uri(scheme: "content", host: "com.example.${XMainApp.blob_nameAPP}.fileprovider", pathSegments: ["external_files", "${XMainApp.blob_nameAPP}.apk"]);
    // Create an AndroidIntent to open the APK file
    final intent = await AndroidIntent(
      action: 'action_view',
      flags: [Flag.FLAG_GRANT_READ_URI_PERMISSION, Flag.FLAG_ACTIVITY_NEW_TASK],
      data: u.toString(),
      type: 'application/vnd.android.package-archive',
    );
    print(intent.data);
    await intent.launch();
    exit(0);
  }

  _buildUI() {
    return Scaffold(
      backgroundColor: XColors.backgroundDark,
      body: Container(
          alignment: Alignment.center,
          margin: EdgeInsets.symmetric(horizontal: 15),
          child: SingleChildScrollView(
              child: Column(mainAxisSize: MainAxisSize.min, children: [
            SizedBox(height: 20),
            widget.title_Text != null
                ? Row(children: [
                    Expanded(
                        child: XContainerWithLabel(
                      widget.title_Text,
                      color: XColors.backGroundTitleContainerForScheda_MAIN,
                      textStyle: widget.title_Style ?? XStyles.xStyTextForTextBase(widget.title_Color ?? XColors.foregroundLight),
                    ))
                  ])
                : Container(),
            SizedBox(height: 3),
            Row(children: [
              Expanded(
                  child: Row(children: [
                Text("Ver. attuale", style: XStyles.xStyTextForDescr()),
                Text(" ${widget.version_APP}", style: XStyles.xStyTextForSubLabel(Colors.yellow)),
              ])),
              SizedBox(width: 10),
              Expanded(
                  child: Row(children: [
                Text("Ver. in CLOUD", style: XStyles.xStyTextForDescr()),
                Text(" ${latestVers}", style: XStyles.xStyTextForSubLabel(Colors.green)),
              ])),
            ]),
            SizedBox(height: 3),
            Container(child: XStatefulWidgetBase.LoaderIndicator(isBusy) ?? Container()),
            SizedBox(height: 5),
          ]))),
      bottomSheet: isBusy.not()
          ? Container(
              height: 60,
              child: Row(children: [
                Expanded(
                    child: XBtnbase(
                  label: "Continua \nsenza aggiornare",
                  onPressed: widget.onCancel,
                  label_Color: Colors.yellow,
                )),
                Expanded(
                    child: XBtnbase(
                  label: "Aggiorna",
                  onPressed: () async => await update_APP(),
                  label_Color: Colors.greenAccent,
                )),
              ]))
          : null,
    );
  }

  @override
  Widget build(BuildContext context) {
    return page ?? Container();
  }
}
